package Entities 
{
	import flash.display.MovieClip;
	import flash.geom.Point;

	public class Ship extends MovieClip 
	{
		private var speed:Point;
		private var speed_multi:Number = .5;
		private var friction:Number = .95;
		public var thrust:int;
		public var rotation_amount:int;
		
		public function Ship(x:int, y:int) 
		{
			super();
			this.x = x;
			this.y = y;
			
			var width:int = 10;
			var height:int = 20;
			
			//Create an internal movieclip to change the rotational point from the top left to the center
			var internal_mc:MovieClip = new MovieClip();			
			internal_mc.graphics.lineStyle(.1, 0xFFFFFF);			
			internal_mc.graphics.moveTo(0, height);
			internal_mc.graphics.lineTo(width / 2, 0);
			internal_mc.graphics.lineTo(width, height);			
			//draw the line across
			internal_mc.graphics.moveTo((7*height/8 -height)/(-height/(width/2)), 7*height/8 );
			internal_mc.graphics.lineTo((7 * height / 8 -height) / (height / (width / 2)) + width, 7 * height / 8);
			
			//offset the internal drawing so the center is around the top left corner
			internal_mc.x = -width / 2;
			internal_mc.y = -height / 2;
			this.addChild(internal_mc);
			
			speed = new Point(0, 0);
			thrust = 0;
			rotation_amount = 0;
		}
		public function Update():void
		{
			x += speed.x;
			y += speed.y;	
			speed.x *= friction;
			speed.y *= friction;
			
			if (thrust != 0)
				Thrust();
				
			if (rotation_amount != 0)
				rotation += rotation_amount;
				
			if (x + width <= 0)
				x = Game.stageWidth - width;
			else if(x >= Game.stageWidth)
				x = 0;
				
			if (y + height <= 0)
				y = Game.stageHeight - height;
			else if(y >= Game.stageHeight)
				y = 0;
		}
		public function Thrust():void
		{			
			var angle_rad:Number = rotation * Math.PI / 180;
			if (thrust == 1)
			{
				speed.x += Math.cos(angle_rad - Math.PI/2) * speed_multi;
				speed.y += Math.sin(angle_rad - Math.PI/2) * speed_multi;			
			}
			else
			{
				speed.x += Math.cos(angle_rad - Math.PI/2) * (-speed_multi);
				speed.y += Math.sin(angle_rad - Math.PI/2) * (-speed_multi);		
			}
		}
	}
}